package com.liang.service.impl;

import com.liang.entity.SysRoleInfo;
import com.liang.dao.SysRoleInfoDao;
import com.liang.service.SysRoleInfoService;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * (SysRoleInfo)表服务实现类
 *
 * @author makejava
 * @since 2023-02-19 21:37:39
 */
@Service("sysRoleInfoService")
public class SysRoleInfoServiceImpl implements SysRoleInfoService {
    @Resource
    private SysRoleInfoDao sysRoleInfoDao;

    /**
     * 通过ID查询单条数据
     *
     * @param roleId 主键
     * @return 实例对象
     */
    @Override
    public SysRoleInfo queryById(Integer roleId) {
        return this.sysRoleInfoDao.queryById(roleId);
    }

    /**
     * 分页查询
     *
     * @param sysRoleInfo 筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    @Override
    public Page<SysRoleInfo> queryByPage(SysRoleInfo sysRoleInfo, PageRequest pageRequest) {
        long total = this.sysRoleInfoDao.count(sysRoleInfo);
        return new PageImpl<>(this.sysRoleInfoDao.queryAllByLimit(sysRoleInfo, pageRequest), pageRequest, total);
    }

    /**
     * 新增数据
     *
     * @param sysRoleInfo 实例对象
     * @return 实例对象
     */
    @Override
    public int insert(SysRoleInfo sysRoleInfo) {
        return this.sysRoleInfoDao.insert(sysRoleInfo);
    }

    /**
     * 修改数据
     *
     * @param sysRoleInfo 实例对象
     * @return
     */
    @Override
    public int update(SysRoleInfo sysRoleInfo) {
        return this.sysRoleInfoDao.update(sysRoleInfo);
    }

    /**
     * 通过主键删除数据
     *
     * @param roleId 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Integer roleId, Integer updateUser) {
        return this.sysRoleInfoDao.deleteById(roleId, updateUser) > 0;
    }

    @Override
    public List<SysRoleInfo> getSysRoleInfoList(Map map) {
        return this.sysRoleInfoDao.getSysRoleInfoList(map);
    }

    /**
     * 禁用一个系统角色
     *
     * @param roleId
     * @return
     */
    @Override
    public int forbid(Integer roleId) {
        return sysRoleInfoDao.forbid(roleId);
    }


    /**
     * 启用一个系统角色
     *
     * @param roleId
     * @return
     */
    @Override
    public int enable(Integer roleId) {
        return sysRoleInfoDao.enable(roleId);
    }

    @Override
    public int batchDelete(List<Integer> roleIdList, Integer updateUser) {
        return this.sysRoleInfoDao.batchDelete(roleIdList, updateUser);
    }

}
